## toulbar2 0.9.8

=== CMakeLists.txt ===
# cmake file for toulbar2 framework building , test and packaging
# version 0.9 
# David allouche 17/10/10
# #################""

cmake_minimum_required(VERSION 2.6)
# source directory
#do not change this variable ==> location of the toulbar2 source code
set (My_cmake_script "${CMAKE_CURRENT_SOURCE_DIR}/cmake-script") # location of cmake script needed 
set (My_Source src)	# source location 
set (My_doc "${CMAKE_CURRENT_SOURCE_DIR}/doc" ) # doxygen repository default ./doc/
set (doc_destination "share/doc")   		#path of doc installation 
set (My_validation "validation")		#validation test location
set (My_benchmark "benchmarks")
set (My_misc_source misc/src/)
list(APPEND CMAKE_MODULE_PATH "${My_cmake_script}/Modules")

set (MAINTAINER "David allouche <david.allouche@toulouse.inra.fr>") #used in packaging 
set (CONTACT "https://mulcyber.toulouse.inra.fr/projects/toulbar2/") #used in packaging

################
# PROJECT NAME
################

project("toulbar2")

	MESSAGE(STATUS "#################################")
	MESSAGE(STATUS " project :${PROJECT_NAME} toolkit compilation cmake file version 0.99")
	MESSAGE(STATUS " source:${CMAKE_CURRENT_SOURCE_DIR} ")
	MESSAGE(STATUS " MAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")
	MESSAGE(STATUS "#################################")

include(CMakeDependentOption)

##########################"

###########################
# cmake option definition
#########################

#	OPTION(TOULBAR2 "toulbar2 solver compilation [default: on]" ON) 
#	OPTION(MENDELSOFT "mendelsoft compilation and packaging option [default:off]" OFF)
	OPTION(WIN32 "toulbar2 cross compilation flag [default: off]" OFF) 

	OPTION(ALL_APP "dedicated applications and toulbar2 solver compilation [default: off]" OFF) 
	OPTION(MENDELSOFT_ONLY "mendelsoft compilation and packaging ONLY ==> remove other exe and lib compilation [default:off]" OFF)
	OPTION(TOULBAR2_ONLY  "toulbar2 solver compilation ONLY  [default: on]" ON) 

	OPTION(LIBTB2 "lib toulbar2 compilation [default: on]" OFF) 
	OPTION(ILOG  "ilog solver binding [default: off]" OFF) 

#	OPTION(LIBTB2INT " lib toulbar2 compilation INT mode required with ilog and windows [default: off]" OFF) 

	OPTION(XML "add a reader for the (W)CSP xml input format [default: off]" OFF)
##	OPTION(CPLEX "encode global cost functions into a linear program solved by CPLEX [default: off]" OFF)
	OPTION(Boost "boost graph binding [default: off]" ON) 
	OPTION(WIDE_STRING  "use wide string to encode long domains in n-ary cost functions/separators [default:on]" ON)
	OPTION(LONG_PROBABILITY  "use long double to encode probabilities [default:on]" ON)

	OPTION(BUILD_API_DOC "build documentation with doxygen [default:on]" ON)
	OPTION(STATIC "static compilation flag [default: on]" OFF)
	OPTION(verbose "verbose mode [default:on]" ON)
	OPTION(COVER_TEST "cover test [default:on]" ON)
	OPTION(BENCH "benchmarcking [default:on]" OFF)
	OPTION(WITH_MEM_JEMALLOC "Enable malloc replacement (http://www.canonware.com/jemalloc)" ON)
	mark_as_advanced(WITH_MEM_JEMALLOC)


###########################
#Default profile for compilation
###########################
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(CMAKE_CXX_FLAGS "-Wall" )

IF(CPLEX)
  SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio126")
  SET(CPLEXFLAGS "-fPIC -fexceptions -fno-strict-aliasing -DILOGCPLEX -DIL_STD -DILOSTRICTPOD -pthread -I${CPLEX_LOCATION}/cplex/include -I${CPLEX_LOCATION}/concert/include")
  SET(CPLEXLIB "-L${CPLEX_LOCATION}/cplex/lib/x86-64_linux/static_pic -L${CPLEX_LOCATION}/concert/lib/x86-64_linux/static_pic") 
  SET(CMAKE_CXX_FLAGS " -Wall ${CPLEXFLAGS}")
  SET(CMAKE_EXE_LINKER_FLAGS " ${CPLEXLIB}")
  SET (all_depends  ${all_depends} "ilocplex") 
  SET (all_depends  ${all_depends} "cplex") 
  SET (all_depends  ${all_depends} "concert") 
  SET (all_depends  ${all_depends} "m") 
  SET (all_depends  ${all_depends} "pthread") 
  SET(STATIC off)
ENDIF(CPLEX)

##########################################
## Compile Options on recent 64 bits Macs. 
# thanks to alex rudnick 
##########################################
IF(APPLE)
  SET(CMAKE_CXX_FLAGS "-Wall -m64" )
  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64" )
  SET(STATIC off)
ENDIF(APPLE)

################
# default OPTION for toulbar2 test  phase
#############
SET(FOPT "test-opt.cmake" CACHE string "filename containing localet  option used for validation ") 
SET(Default_test_option CACHE STRING "Define toulbar2 option used in command line for testing: cf toulbar2 command line.")
SET(Default_test_timeout 300 CACHE INTEGER "default test timeout")
SET(Default_validation_dir "validation" CACHE string "default location of benchmark file")
SET(Default_cover_dir "cover" CACHE string "default location of cover test file ")
SET(Default_regexp "end." CACHE string "default regex searched in test output")

SET(Default_BenchDir "benchmarks" CACHE string "default location of benchmark file")
SET(Default_BenchFormat "wcsp" CACHE string "default format extension for benchmark file search") 
SET(Default_bench_timeout 30 CACHE INTEGER "default timeout used for benchmarking ")
SET(Default_bench_option "TOULBAR2_OPTION" CACHE STRING " option used in command line for benchmarking.")
SET(Default_bench_regexp "test ok" CACHE string "default regex searched in bench output")


	MARK_AS_ADVANCED(FORCE LIBTB2 BUILD_API_DOC verbose Boost FOPT CMAKE_INSTALL_PREFIX Default_test_timeout WIDE_STRING LONG_PROBABILITY)
	MARK_AS_ADVANCED(FORCE BUILD_SHARED_LIBS)

#############"
# static building
#############

IF(STATIC)
	set (CMAKE_CXX_FLAGS "-Wall -static -static-libgcc" )
	MESSAGE(STATUS "STATIC COMPILATION ON (warning: boost and xml  option not compliant with static link)")
	SET(BUILD_SHARED_LIBS "${BUILD_SHARED_LIBS}" CACHE BOOL "Set to OFF to build static libraries" FORCE )
	
ELSE()
	SET(BUILD_SHARED_LIBS ON) #shared library building
ENDIF(STATIC)


if(verbose) 
	set (CMAKE_VERBOSE_MAKEFILE ON)
endif(verbose)

##########################
# OPTION DEPENDANCES 
##########################"
	SET(Toulbar_NAME "toulbar2") # default project name

IF(ALL_APP)
        MESSAGE(STATUS "#################################")
        MESSAGE(STATUS " TOULBAR2 and MENDELSOFT COMPILATION AND PACKAGING ")
        MESSAGE(STATUS "#################################")

	SET(TOULBAR2_ONLY OFF)
	SET(MENDELSOFT_ONLY OFF)
        SET(MENDELSOFT ON)
        SET(TOULBAR2 ON)
        SET(ILOG OFF)
        SET(LIBTB2 ON)
        SET(XML ON)
        SET(CPLEX OFF)
        SET(boost ON)
        set (Toulbar_NAME "toulbar2-all")
        project(${Toulbar_NAME})
#description used in the package building
   	  SET(Toulbar_PACKAGE_DESCRIPTION "${Toulbar_NAME} is a C++ free open source framework including an exact solver and associated library for discrete graphical model optimization.")
        SET(Toulbar_PACKAGE_SUMMARY "${Toulbar_NAME} Exact optimization solver for discrete graphical models (cost function networks).")

ENDIF(ALL_APP)


IF(MENDELSOFT_ONLY)
	MESSAGE(STATUS "#################################")
	MESSAGE(STATUS " MENDELSOFT COMPILATION AND PACKAGING ONLY")
	MESSAGE(STATUS "#################################")

	SET(MENDELSOFT ON)
	SET(TOULBAR2 OFF)
	SET(TOULBAR2_ONLY OFF)
	SET(ILOG OFF)
	SET(LIBTB2 OFF)
	SET(XML OFF)
	SET(CPLEX OFF)
	SET(boost OFF)

#basename for packagin and versionning
	set (Toulbar_NAME "mendelsoft")
#description used in the package building
	SET (Toulbar_PACKAGE_DESCRIPTION 
	"MendelSoft is an open source software which detects marker genotyping incompatibilities (Mendelian errors only) in complex pedigrees using weighted constraint satisfaction techniques. The input of the software is a pedigree with genotyping data at a single locus. The output of the software is a list of individuals such that the removal of their genotyping data restores consistency. This list is of minimum size when the program terminates.") 
        SET(Toulbar_PACKAGE_SUMMARY "${Toulbar_NAME} is an open source software which detect Mendelian errors in complex pedigrees using weighted constraint satisfaction techniques")
#############

ENDIF(MENDELSOFT_ONLY)

IF(TOULBAR2_ONLY)
        MESSAGE(STATUS "#################################")
        MESSAGE(STATUS " TOULBAR2 Solver Compilation and Packaging Only")
        MESSAGE(STATUS "#################################")

        SET(MENDELSOFT OFF)
        SET(TOULBAR2 ON)
        SET(ILOG OFF)
        SET(LIBTB2 OFF)
#basename for packagin and versionning
        SET(Toulbar_NAME "toulbar2")
#description used in the package building
	SET(Toulbar_PACKAGE_DESCRIPTION "${Toulbar_NAME} is a free open source solver for constraints network optimization written in C++. Its purpose is solve combinatory problem in the weighted csp framework.")
        SET(Toulbar_PACKAGE_SUMMARY "${Toulbar_NAME}  solver for network of cost function (WCSP framework)")
ENDIF(TOULBAR2_ONLY)

##############################
IF(ILOG)
	set(LIBTB2INT ON)
ENDIF(ILOG)

SET(EXECUTABLE_OUTPUT_PATH bin/${CMAKE_SYSTEM_NAME})
SET(LIBRARY_OUTPUT_PATH lib/${CMAKE_SYSTEM_NAME})

#########################
IF(WIN32)
# option used for cross compilation 
	set (EXE ".exe")
	set(COST INT_COST)
	set(LIBTB2INT OFF)
	set(XML OFF)
	set(CPLEX OFF)
	set(Boost OFF)
	set(ILOG OFF)
	set(LIBTB2 OFF)

######################################
	MESSAGE(STATUS "WIN32 on  .")
	MESSAGE(STATUS "COST ==> int.")
######################################

# mingW32 env setup
	include(${My_cmake_script}/mingw32-config.cmake) 

ELSE(WIN32)

	SET(COST LONGLONG_COST)
	MESSAGE(STATUS "COST ==>  long long")


ENDIF(WIN32)

###########
# find opt libs 
###########
if(WITH_MEM_JEMALLOC)
  find_package(JeMalloc)
  if(NOT JEMALLOC_FOUND)
    set(WITH_MEM_JEMALLOC OFF)
  endif()
endif()

if(WITH_MEM_JEMALLOC)
  link_directories(${JEMALLOC_LIBPATH})
  SET (all_depends  ${all_depends} "jemalloc") 
endif()

MESSAGE(STATUS "search for GMP library")
INCLUDE(FindPkgConfig)
include(${My_cmake_script}/FindGmp.cmake)
SET (all_depends  ${all_depends} "gmp") 
#INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR}) 

#CMAKE_DEPENDENT_OPTION(ILOG "ILOGLUE COMPIATION" OFF  "LIBTB2INT" OFF)
#########################
INCLUDE(FindPkgConfig)
INCLUDE(FindGit)

# list of files used for compilation are included in source_file.cmake 
# new file need to be added to this list
# you can also define your own list and add it to the wall list
# for example: SET (source_files ${source_files} ${my_file_2add})

include(${My_cmake_script}/source_files.cmake)

########################

IF(Boost) 
  include(${My_cmake_script}/Boost_option.cmake)
ENDIF(Boost)

####################
#  FLAG XML ON  ==> xmlcps supported
#######################

include(${My_cmake_script}/xmlcsp.cmake)


################
# build executable
#################

INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR}/${My_Source} )

IF(TOULBAR2)
  add_executable(toulbar2${EXE} ${source_files})
  ADD_CUSTOM_TARGET(gen_version ALL /bin/sh ${CMAKE_CURRENT_SOURCE_DIR}/cmake-script/genVersionFile.sh)
  SET_SOURCE_FILES_PROPERTIES(ToulbarVersion.hpp PROPERTIES GENERATED 1)
  TARGET_LINK_LIBRARIES(toulbar2${EXE} ${all_depends})
  INSTALL( TARGETS toulbar2${EXE} DESTINATION bin )
ENDIF(TOULBAR2)

###############
# mendelsoft compilation
###############

IF(MENDELSOFT)
  add_executable(mendelsoft${EXE} ${source_files})
  ADD_CUSTOM_TARGET(gen_version ALL /bin/sh ${CMAKE_CURRENT_SOURCE_DIR}/cmake-script/genVersionFile.sh)
  SET_SOURCE_FILES_PROPERTIES(ToulbarVersion.hpp PROPERTIES GENERATED 1)
  TARGET_LINK_LIBRARIES(mendelsoft${EXE} ${all_depends})
  install( TARGETS mendelsoft${EXE} DESTINATION bin )
ENDIF(MENDELSOFT)


# we must delete INT_COST

###############################################
# LIBTB2INTCOST GENERATION 
###############################################
IF(LIBTB2)
	IF(WIN32)

=== misc/script/Makefile ===
SRCSFULL = $(wildcard tb2*.cpp incop/*.cpp)

# Comment the following line if BOOST Graph library uninstalled
BOOST = -DBOOST

# Same thing for XML
#XML = XMLFLAG
#XMLI = -I/usr/include/libxml2 -DXMLFLAG
# -DXMLFLAG -DMAXCSP

ifeq ($(BOOST),-DBOOST)
SRCS = $(SRCSFULL)
else
SRCS = $(SRCSFULL:tb2boostgraph.cpp=)
endif

ifeq ($(XML),XMLFLAG)
OBJS = $(SRCS:.cpp=.o) -lxml2 -lgmp
# -lxml2 -lz -lm -lpthread
else
OBJS = $(SRCS:.cpp=.o) -lgmp
endif

LIBSRCS = $(SRCS:tb2main.cpp=)
LIBOBJS = $(LIBSRCS:.cpp=.o)

CC = g++

# Library compatible with Ilog Solver:
# In order to link ToulBar2 with Ilog Solver, uncomment the following two lines starting with ILOGFLAGS and ILOGLIBS, and uncomment #define INT_COST (also adding comment to #define LONGLONG_COST) in tb2types.hpp
# Then recompile libtb2.so (make clean;make libtb2.so) and finaly compile iloglue (make iloglue)
# Usage: iloglue 16wqueens.wcsp [verbosity level]
# Ilog Solver 6.0
#ILOGFLAGS = -DILOGLUE -DIL_STD -I/usr/local/Ilog/solver60/include -I/usr/local/Ilog/concert20/include
#ILOGLIBS = -L/usr/local/Ilog/solver60/lib/i86_linux2_glibc2.3_gcc3.2/static_pic -L/usr/local/Ilog/concert20/lib/i86_linux2_glibc2.3_gcc3.2/static_pic -lsolverfloat -lsolver -lconcert
# Ilog Solver 6.5
# (warning: compile libtb2.so and iloglue with -O optimization and not -O3)
#ILOGFLAGS = -DILOGLUE -DIL_STD -I/usr/local/ILOG/solver65/include -I/usr/local/ILOG/concert25/include
#ILOGLIBS = -L/usr/local/ILOG/solver65/lib/x86-64_rhel4.0_3.4/static_pic -L/usr/local/ILOG/concert25/lib/x86-64_rhel4.0_3.4/static_pic -lsolverfloat -lsolver -lconcert

## PLPS cost functions needs CPLEX installed (update the following path depending on your configuration and uncomment the following three lines) *** Warning! Beta untested version for PLPS ***
##CPLEX_LOCATION = /opt/ibm/ILOG/CPLEX_Studio126
##CPLEXFLAGS = -DILOGCPLEX -DIL_STD -fPIC -fexceptions -fno-strict-aliasing -pthread -I$(CPLEX_LOCATION)/cplex/include/ilcplex -I$(CPLEX_LOCATION)/cplex/include -I$(CPLEX_LOCATION)/concert/include
##CPLEXLIB =  -L$(CPLEX_LOCATION)/cplex/lib/x86-64_linux/static_pic -L$(CPLEX_LOCATION)/concert/lib/x86-64_linux/static_pic -lilocplex -lcplex -lconcert -pthread -rdynamic 

CFLAGS = -g -Wall -I. $(ILOGFLAGS) $(BOOST) $(XMLI) -DLINUX -DLONGLONG_COST -DWIDE_STRING -DLONGDOUBLE_PROB -DNARYCHAR -DWCSPFORMATONLY
# -DLINUX # compile on linux computers
# -DLONGLONG_COST # uses type long long for encoding costs
# -DWIDE_STRING # uses wide strings (2 bytes per char) for encoding value tuples (including separators)
# -DLONGDOUBLE_PROB # uses type long double for encoding (log) probabilities
# -DNARYCHAR # pretty prints of nary constraints (including separators)
# -DWCSPFORMATONLY # assumes positive domains starting at value 0 (as in the wcsp format file) *** Incompatible with Numberjack ***
# -DNUMBERJACK # 
# -ftrapv -g3 # catches numerical integer overflows

OFLAGS = -O3 -DNDEBUG
# -O3 -DNDEBUG

PFLAGS = 
# -pg -g3

BUILD = $(CC) -shared

%.o : %.cpp
	$(CC) $(OFLAGS) $(CFLAGS) $(LIBFLAGS) -c -o $@  $< $(PFLAGS)

%.o : %.cpp %.hpp
	$(CC) $(OFLAGS) $(CFLAGS) $(LIBFLAGS) -c -o $@  $< $(PFLAGS)

%.o : %.cpp %.h
	$(CC) $(OFLAGS) $(CFLAGS) $(LIBFLAGS) -c -o $@  $< $(PFLAGS)

toulbar2: $(OBJS)
	$(CC) $(OBJS) -o $@ $(PFLAGS) -static -static-libgcc

libtb2.so: LIBFLAGS = -fPIC
libtb2.so: $(LIBOBJS)
	$(BUILD) $(LIBFLAGS) $(LIBOBJS) -o $@

toulbar2test: toulbar2test.cpp libtb2.so
	$(CC) $(OFLAGS) $(CFLAGS) -o $@ $< ./libtb2.so -lgmp

iloglue: iloglue.cpp libtb2.so
	$(CC) $(OFLAGS) $(CFLAGS) -o $@ $< $(ILOGLIBS) -L. -ltb2 -lgmp

clean:
	-rm -f *.o incop/*.o toulbar2 libtb2.so iloglue toulbar2test

all: toulbar2

=== debian/control ===
Source: toulbar2
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libgmp-dev,
               libboost-dev,
               libboost-graph-dev,
               libjemalloc-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/toulbar2.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/toulbar2.git
Homepage: http://www.inra.fr/mia/T/toulbar2

Package: toulbar2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Exact combinatorial optimization for Graphical Models
 Toulbar2 is  an exact discrete optimization tool for Graphical Models 
 such as Cost Function Networks, Markov Random Fields, Weighted Constraint 
 Satisfaction Problems and Bayesian Nets.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:STRING=Release
	# RelWithDebInfo is slower

override_dh_auto_test:
	# Don't run CTest. 
	# Ran by developpers and may timeout on slow platforms.

=== debian/watch ===
version=3
https://mulcyber.toulouse.inra.fr/frs/?group_id=29 /frs/download\.php/\d+/toulbar2_([\d\.]*)\.orig\.tar\.xz

## toulbar2 1.0.0%2Bdfsg3

=== debian/control ===
Source: toulbar2
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               cmake,
               bc,
               doxygen,
               doxygen-latex,
               libgmp-dev,
               graphviz,
               libboost-graph-dev,
               libboost-iostreams-dev,
               libjemalloc-dev,
               zlib1g-dev,
               pkg-config
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/toulbar2
Vcs-Git: https://salsa.debian.org/science-team/toulbar2.git
Homepage: http://www.inra.fr/mia/T/toulbar2

Package: toulbar2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: toulbar2-doc
Description: Exact combinatorial optimization for Graphical Models
 Toulbar2 is  an exact discrete optimization tool for Graphical Models
 such as Cost Function Networks, Markov Random Fields, Weighted Constraint
 Satisfaction Problems and Bayesian Nets.

Package: toulbar2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Exact combinatorial optimization for Graphical Models - documentation
 Toulbar2 is  an exact discrete optimization tool for Graphical Models
 such as Cost Function Networks, Markov Random Fields, Weighted Constraint
 Satisfaction Problems and Bayesian Nets.
 .
 This package contains the API reference and user documentation, descriptions
 of the various file formats that toulbar2 can read as well as examples.

## toulbar2 1.0.0+dfsg3

=== CMakeLists.txt ===
##########################################
# cmake file for toulbar2 framework building , test and packaging
# version 0.9 
# David allouche 17/10/10
##########################################

cmake_minimum_required(VERSION 2.6)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set (My_cmake_script "${CMAKE_CURRENT_SOURCE_DIR}/cmake-script") # location of cmake script needed 
set (My_Source src)	# source location 
set (doc_destination "share/doc")   		#path of doc installation 
set (My_validation "validation")		#validation test location
set (My_benchmark "benchmarks")
set (My_misc_source misc/src/)
list(APPEND CMAKE_MODULE_PATH "${My_cmake_script}/Modules")

set (MAINTAINER "David Allouche <david.allouche@inra.fr>") #used in packaging 
set (CONTACT "https://github.com/toulbar2/toulbar2") #used in packaging

##########################################
# PROJECT NAME
##########################################

project("toulbar2")

MESSAGE(STATUS "##########################################")
MESSAGE(STATUS "project :${PROJECT_NAME} toolkit compilation cmake file version 0.99")
MESSAGE(STATUS "source:${CMAKE_CURRENT_SOURCE_DIR} ")
MESSAGE(STATUS "MAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "##########################################")

include(CMakeDependentOption)

##########################################
# cmake option definition
##########################################

#	OPTION(TOULBAR2 "toulbar2 solver compilation [default: on]" ON) 
#	OPTION(MENDELSOFT "mendelsoft compilation and packaging option [default:off]" OFF)
OPTION(WIN32 "toulbar2 cross compilation flag [default: off]" OFF) 
OPTION(ALL_APP "dedicated applications and toulbar2 solver compilation [default: off]" OFF) 
OPTION(MENDELSOFT_ONLY "mendelsoft compilation and packaging ONLY ==> remove other exe and lib compilation [default:off]" OFF)
OPTION(TOULBAR2_ONLY  "toulbar2 solver compilation ONLY  [default: on]" ON) 
OPTION(LIBTB2 "lib toulbar2 compilation [default: off]" OFF) 
OPTION(ILOG  "ilog solver binding [default: off]" OFF) 
#	OPTION(LIBTB2INT " lib toulbar2 compilation INT mode required with ilog and windows [default: off]" OFF) 
OPTION(XML "add a reader for the (W)CSP xml input format [default: off]" OFF)
##	OPTION(CPLEX "encode global cost functions into a linear program solved by CPLEX [default: off]" OFF)
OPTION(Boost "boost graph binding [default: on]" ON) 
OPTION(MPI "MPI [default: on]" OFF)
OPTION(WIDE_STRING  "use wide string to encode long domains in n-ary cost functions/separators [default:on]" ON)
OPTION(LONG_COSTS  "use long long to encode costs [default:on]" ON)
OPTION(LONG_PROBABILITY  "use long double to encode probabilities [default:on]" ON)
OPTION(BUILD_API_DOC "build and install HTML documentation with doxygen [default:off]" OFF)
OPTION(BUILD_API_DOC_LATEX "build and install LaTeX PDF documentation with doxygen [default:off]" OFF)
OPTION(STATIC "static compilation flag [default: off]" OFF)
OPTION(verbose "verbose mode [default:on]" ON)
OPTION(COVER_TEST "cover test [default:on]" ON)
OPTION(BENCH "benchmarcking [default:off]" OFF)
OPTION(WITH_MEM_JEMALLOC "Enable malloc replacement (http://www.canonware.com/jemalloc) [default on]" ON)
mark_as_advanced(WITH_MEM_JEMALLOC BUILD_API_DOC_LATEX)

##########################################
#Default profile for compilation
##########################################
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the build type, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(CMAKE_CXX_FLAGS "-Wall -std=c++11" )

IF(CPLEX)
  SET(CPLEX_LOCATION "/opt/ibm/ILOG/CPLEX_Studio126")
  SET(CPLEXFLAGS "-fPIC -fexceptions -fno-strict-aliasing -DILOGCPLEX -DIL_STD -DILOSTRICTPOD -pthread -I${CPLEX_LOCATION}/cplex/include -I${CPLEX_LOCATION}/concert/include")
  SET(CPLEXLIB "-L${CPLEX_LOCATION}/cplex/lib/x86-64_linux/static_pic -L${CPLEX_LOCATION}/concert/lib/x86-64_linux/static_pic") 
  SET(CMAKE_CXX_FLAGS " -Wall ${CPLEXFLAGS}")
  SET(CMAKE_EXE_LINKER_FLAGS " ${CPLEXLIB}")
  SET (all_depends  ${all_depends} "ilocplex") 
  SET (all_depends  ${all_depends} "cplex") 
  SET (all_depends  ${all_depends} "concert") 
  SET (all_depends  ${all_depends} "m") 
  SET (all_depends  ${all_depends} "pthread") 
  SET(STATIC off)
ENDIF(CPLEX)

##########################################
# Compile Options on recent 64 bytes Macs. 
# thanks to alex rudnick 
##########################################
IF(APPLE)
  SET(CMAKE_CXX_FLAGS "-Wall -m64" )
  SET(CMAKE_SHARED_LINKER_FLAGS "-Wall -m64" )
  SET(STATIC off)
ENDIF(APPLE)

##########################################
# default OPTION for toulbar2 test  phase
##########################################
SET(FOPT "test-opt.cmake" CACHE string "filename containing local options used for validation")
SET(Default_test_option CACHE STRING "Define toulbar2 option used in command line for testing: cf toulbar2 command line")
SET(Default_test_timeout 300 CACHE INTEGER "default test timeout")
SET(Default_validation_dir "validation" CACHE string "default location of benchmark file")
SET(Default_cover_dir "cover" CACHE string "default location of cover test file ")
SET(Default_regexp "end." CACHE string "default regex searched in test output")

SET(Default_BenchDir "benchmarks" CACHE string "default location of benchmark file")
SET(Default_BenchFormat "wcsp" CACHE string "default format extension for benchmark file search") 
SET(Default_bench_timeout 30 CACHE INTEGER "default timeout used for benchmarking ")
SET(Default_bench_option "TOULBAR2_OPTION" CACHE STRING " option used in command line for benchmarking.")
SET(Default_bench_regexp "test ok" CACHE string "default regex searched in bench output")

MARK_AS_ADVANCED(FORCE LIBTB2 verbose Boost FOPT CMAKE_INSTALL_PREFIX Default_test_timeout WIDE_STRING LONG_PROBABILITY LONG_COSTS)
MARK_AS_ADVANCED(FORCE BUILD_SHARED_LIBS GMP_LIBRARY)

IF (MPI)
  SET(Boost ON)
  SET(STATIC OFF)
ENDIF(MPI)

##########################################
# static building
##########################################

IF(STATIC)
  set (CMAKE_CXX_FLAGS "-Wall -static -static-libgcc" )
  MESSAGE(STATUS "STATIC COMPILATION ON (warning: boost and xml and MPI options not compliant with static link)")
  SET(BUILD_SHARED_LIBS "${BUILD_SHARED_LIBS}" CACHE BOOL "Set to OFF to build static libraries" FORCE )
  
ELSE()
  SET(BUILD_SHARED_LIBS ON) #shared library building
ENDIF(STATIC)

if(verbose) 
  set (CMAKE_VERBOSE_MAKEFILE ON)
endif(verbose)

##########################################
# OPTION DEPENDANCES 
##########################################
SET(Toulbar_NAME "toulbar2") # default project name

IF(ALL_APP)
  MESSAGE(STATUS "##########################################")
  MESSAGE(STATUS " TOULBAR2 and MENDELSOFT COMPILATION AND PACKAGING ")
  MESSAGE(STATUS "##########################################")
  
  SET(TOULBAR2_ONLY OFF)
  SET(MENDELSOFT_ONLY OFF)
  SET(MENDELSOFT ON)
  SET(TOULBAR2 ON)
  SET(ILOG OFF)
  SET(LIBTB2 ON)
  SET(XML ON)
  SET(CPLEX OFF)
  SET(boost ON)
  set (Toulbar_NAME "toulbar2-all")
  project(${Toulbar_NAME})
  #description used in the package building
	SET(Toulbar_PACKAGE_DESCRIPTION "${Toulbar_NAME} is an open source C++ exact solver and library for graphical model optimization. It can solve MAP/Markov Random Fields or Cost Function Networks/Weighted CSP.")
        SET(Toulbar_PACKAGE_SUMMARY "${Toulbar_NAME} exact solver for graphical models.")
  
ENDIF(ALL_APP)


IF(MENDELSOFT_ONLY)
  MESSAGE(STATUS "##########################################")
  MESSAGE(STATUS " MENDELSOFT COMPILATION AND PACKAGING ONLY")
  MESSAGE(STATUS "##########################################")
  
  SET(MENDELSOFT ON)
  SET(TOULBAR2 OFF)
  SET(TOULBAR2_ONLY OFF)
  SET(ILOG OFF)
  SET(LIBTB2 OFF)
  SET(XML OFF)
  SET(CPLEX OFF)
  SET(Boost OFF)
  set(MPI OFF)
  
  #basename for packaging and versioning
  set (Toulbar_NAME "mendelsoft")
  #description used in the package building
  SET (Toulbar_PACKAGE_DESCRIPTION 
    "MendelSoft is an open source software which detects marker genotyping incompatibilities (Mendelian errors only) in complex pedigrees using weighted constraint satisfaction techniques. The input of the software is a pedigree data with genotyping data at a single locus. The output of the software is a list of individuals for which the removal of their genotyping data restores consistency. This list is of minimum size when the program ends.") 
  SET(Toulbar_PACKAGE_SUMMARY "${Toulbar_NAME} is an open source software which detect Mendelian errors  in complex pedigrees using weighted constraint satisfaction techniques")
  
ENDIF(MENDELSOFT_ONLY)

IF(TOULBAR2_ONLY)
  MESSAGE(STATUS "##########################################")
  MESSAGE(STATUS " TOULBAR2 Solver Compilation and Packaging Only")
  MESSAGE(STATUS "##########################################")
  
  SET(MENDELSOFT OFF)
  SET(TOULBAR2 ON)
  SET(ILOG OFF)
  SET(LIBTB2 OFF)
  #basename for packagin and versionning
  SET(Toulbar_NAME "toulbar2")
  #description used in the package building
	SET(Toulbar_PACKAGE_DESCRIPTION "${Toulbar_NAME} is an open source C++ exact solver and library for graphical model optimization. It can solve MAP/Markov Random Fields or Cost Function Networks/Weighted CSP.")
        SET(Toulbar_PACKAGE_SUMMARY "${Toulbar_NAME} exact solver for graphical models.")
ENDIF(TOULBAR2_ONLY)

##########################################
IF(ILOG)
  set(LIBTB2INT ON)
ENDIF(ILOG)

SET(EXECUTABLE_OUTPUT_PATH bin/${CMAKE_SYSTEM_NAME})
SET(LIBRARY_OUTPUT_PATH lib/${CMAKE_SYSTEM_NAME})

##########################################
IF(WIN32)
  # option used for cross compilation 
  set ( EXE ".exe")
  set(COST INT_COST)
  set(LIBTB2INT OFF)
  set(XML OFF)
  set(CPLEX OFF)
  set(Boost OFF)
  set(MPI OFF)
  set(ILOG OFF)
  set(LIBTB2 OFF)
  
  MESSAGE(STATUS "WIN32 on  .")
  MESSAGE(STATUS "COST ==> int.")

# mingW32 env setup
include(${My_cmake_script}/mingw32-config.cmake) 

ELSE(WIN32)
  
  SET(COST LONGLONG_COST)
  MESSAGE(STATUS "COST ==>  long long")

ENDIF(WIN32)

##########################################
# find opt libs 
##########################################
if(WITH_MEM_JEMALLOC)
  find_package(JeMalloc)
  if(JEMALLOC_FOUND)
    link_directories(${JEMALLOC_LIBPATH})
    SET (all_depends  ${all_depends} "jemalloc") 
  endif()
endif()

MESSAGE(STATUS "search for GMP library")
INCLUDE(FindPkgConfig)
include(${My_cmake_script}/FindGmp.cmake)
SET (all_depends  ${all_depends} "gmp") 
INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR}) 

#CMAKE_DEPENDENT_OPTION(ILOG "ILOGLUE COMPILATION" OFF  "LIBTB2INT" OFF)
##########################################
INCLUDE(FindPkgConfig)
INCLUDE(FindGit)

# list of files used for compilation are included in source_file.cmake 
# new file need to be added to this list
# you can also define your own list and add it to the wall list
# for example: SET (source_files ${source_files} ${my_file_2add})

include(${My_cmake_script}/source_files.cmake)

##########################################
IF(Boost) 
  include(${My_cmake_script}/Boost_option.cmake)
  link_directories(${Boost_LIBRARY_DIR})
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
ENDIF(Boost)

##########################################
IF(MPI) 
#  SET(CMAKE_C_COMPILER mpicc)
#  SET(CMAKE_CXX_COMPILER mpicxx)
#  SET(CMAKE_CXX_COMPILER /usr/mpi/gcc/openmpi-1.10.3rc4/bin/mpicxx)
#  SET(CMAKE_SYSTEM_PREFIX_PATH /usr/mpi/gcc/openmpi-1.10.3rc4)
  find_package(MPI REQUIRED)
  include_directories(${MPI_INCLUDE_PATH})
  SET (mpiflag OPENMPI)
ENDIF(MPI)

##########################################
#  FLAG XML ON  ==> xmlcps supported
##########################################
include(${My_cmake_script}/xmlcsp.cmake)

##########################################
# build executable
##########################################
INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR}/${My_Source} )

IF(TOULBAR2)
  add_executable(toulbar2${EXE} ${source_files})

=== misc/script/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-SRCSFULL = $(wildcard tb2*.cpp incop/*.cpp)
+SRCSFULL = $(wildcard tb2*.cpp applis/*.cpp core/*.cpp globals/*.cpp incop/*.cpp search/*.cpp utils/*.cpp vns/*.cpp ToulbarVersion.cpp)
 
 # Comment the following line if BOOST Graph library uninstalled
 BOOST = -DBOOST
@@ -11,7 +11,7 @@
 ifeq ($(BOOST),-DBOOST)
 SRCS = $(SRCSFULL)
 else
-SRCS = $(SRCSFULL:tb2boostgraph.cpp=)
+SRCS = $(SRCSFULL:utils/tb2boostgraph.cpp=)
 endif
 
 ifeq ($(XML),XMLFLAG)
@@ -45,18 +45,19 @@
 
 CFLAGS = -g -Wall -I. $(ILOGFLAGS) $(BOOST) $(XMLI) -DLINUX -DLONGLONG_COST -DWIDE_STRING -DLONGDOUBLE_PROB -DNARYCHAR -DWCSPFORMATONLY
 # -DLINUX # compile on linux computers
-# -DLONGLONG_COST # uses type long long for encoding costs
-# -DWIDE_STRING # uses wide strings (2 bytes per char) for encoding value tuples (including separators)
-# -DLONGDOUBLE_PROB # uses type long double for encoding (log) probabilities
+# -DLONGLONG_COST # uses type long long for encoding costs, to be replaced by -DINT_COST if memory is an issue (but costs are limited to 119304647)
+# -DWIDE_STRING # uses wide strings (2 bytes per char instead of one) for encoding value tuples (including separators)
+# -DLONGDOUBLE_PROB # uses type long double for encoding (log) probabilities instead of type double if using -DDOUBLE_PROB
 # -DNARYCHAR # pretty prints of nary constraints (including separators)
 # -DWCSPFORMATONLY # assumes positive domains starting at value 0 (as in the wcsp format file) *** Incompatible with Numberjack ***
 # -DNUMBERJACK # 
+# -DOPENMPI # enables variable neighborhood search
 # -ftrapv -g3 # catches numerical integer overflows
 
 OFLAGS = -O3 -DNDEBUG
 # -O3 -DNDEBUG
 
-PFLAGS = 
+PFLAGS =
 # -pg -g3
 
 BUILD = $(CC) -shared
@@ -84,6 +85,6 @@
 	$(CC) $(OFLAGS) $(CFLAGS) -o $@ $< $(ILOGLIBS) -L. -ltb2 -lgmp
 
 clean:
-	-rm -f *.o incop/*.o toulbar2 libtb2.so iloglue toulbar2test
+	-rm -f *.o applis/*.o core/*.o globals/*.o incop/*.o search/*.o utils/*.o vns/*.o toulbar2 libtb2.so iloglue toulbar2test
 
 all: toulbar2

=== debian/changelog ===
toulbar2 (1.0.0+dfsg3-2build2) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:13:14 +0100

toulbar2 (1.0.0+dfsg3-2build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:49:01 +0000

toulbar2 (1.0.0+dfsg3-2) unstable; urgency=medium

  * Team upload.
  * debhelper 12
  * Standards-Version: 4.3.0
  * Remove trailing whitespace in debian/copyright
  * Add missing Build-Depends: pkg-config
  * Prevent generation of PDF documentation since otherwise toulbar2 does
    not build (see bug #920459).  This means should be reverted once doxygen
    is fixed.
  * toulbar2-doc: Section: doc

 -- Andreas Tille <tille@debian.org>  Mon, 18 Feb 2019 22:17:10 +0100

toulbar2 (1.0.0+dfsg3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add the missing build dependency on zlib1g-dev. (Closes: #916715)

 -- Adrian Bunk <bunk@debian.org>  Fri, 11 Jan 2019 13:47:51 +0200

toulbar2 (1.0.0+dfsg3-1) unstable; urgency=medium

  [ Thomas Schiex ]
  * Developer documentation regenerated and removed from upstream. User,
  developer and formats documentation installed in suitable location
  and registered via doc-base in a separate toulbar2-doc package. Examples
  provided as tar.xz balls.

  [ Aaron M. Ucko ]
  * Sponsor upload to unstable.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 12 Aug 2018 23:22:14 -0400

toulbar2 (1.0.0+dfsg-1) unstable; urgency=medium

  * New major release. Includes DGVNS parallelized search method,
  new JSON compatible CFN input format that allows for negative or
  decimal costs as well as maximization, and clique cover global
  constraint (Closes: Bug#831148).

 -- Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>  Thu, 28 Jun 2018 17:35:05 +0200

toulbar2 (0.9.8-1) unstable; urgency=medium

  * Initial release.
  * Closes: #780516 (ITP: toulbar2 - Exact optimization solver for Graphical Models.)

 -- Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>  Thu, 28 Apr 2016 00:33:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: toulbar2
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Schiex <Thomas.Schiex@toulouse.inra.fr>
 Section: science
 Priority: optional

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%toulbar2-$1.tar.gz%" \
     https://github.com/toulbar2/toulbar2/tags \
     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
